import express from "express";
const router = express.Router();

import db from "../../lib/sql";

const query = "insert into `pastes` (`uuid`,`lang`,`desc`,`paste`,`hidden`,`reply`) "
            + "values (LEFT(UUID(), 8), ?, ?, ?, ?, ?)";
let languages = new Map();
db.exec("select * from `languages`")
  .then(rows => rows.forEach(r => languages.set(r.id, r.name)))
  .catch(err => console.log(err));

export default express.Router()
  .get("/", (req, res) => {
    res.render("index", { languages: [...languages.values()] } )
  })
  .post("/", (req, res) => {
    const data = {
      desc: req.body.desc || null,
      content: req.body.content || false,
      lang: languages.getKey(req.body.lang) || 1,
      hidden: req.body.hidden || 0,
      reply: req.body.reply || 0
    };
    if(!data.content)
      return res.render("index", { languages: [...languages.values()], notification: "nope" });
    db.exec(query, [
      data.lang,
      data.desc,
      new Buffer(data.content).toString("base64"),
      data.hidden,
      data.reply
    ]).then(insert => {
      db.exec("select `uuid` from `pastes` where `id` = ? limit 1", [insert.insertId]).then(rows => {
        res.redirect(`/${rows[0].uuid}/`);
      }).catch(err => res.render("index", { languages: [...languages.values()], notification: "lol" }));
    }).catch(err => res.render("index", { languages: [...languages.values()], notification: "didn't insert your paste lol" }));
  });

Map.prototype.getKey = function(val) {
  for (let [key, value] of this)
    if(value.toLowerCase() === val.toLowerCase())
      return key;
  return false;
};